import es, gamethread, cfglib, services

info = es.AddonInfo()
info.name     = "Bullet Time CSS"
info.version  = "0.1"
info.url      = "None"
info.basename = "sic_bt"
info.author   = "sicman_adrian"
es.ServerVar(info.basename, info.version, 'Bullet Time').makepublic()

player_dict = {}

timescale = es.ServerVar('host_timescale')
# In autoexec you should have 

#es_load examples/auth/basic_auth
#BASIC_AUTH_ADMIN_LIST "STEAM_ID_LAN;STEAM_X:X:XXXXXX;"

config = cfglib.AddonCFG(es.getAddonPath("bullettime") + "/bullettime.cfg")
config.text("**************************")
config.text("       Bullet Time        ")
config.text("**************************")
sic_bullettime   = config.cvar("sic_bullettime",   1, "Enables/Disables bullet time together")
config.text("@trigger <time> <how slow - 0.2>")
sic_bullettime_trigger   = config.cvar("sic_bullettime_trigger",   '@trigger', " What you type to to Trigger Bullet Time for admins only.")
sic_bullettime_sound_enter   = config.cvar("sic_bullettime_sound_enter",   'mb_bullettime/enter1.mp3', "The Sound when bullet time begins")
sic_bullettime_sound_end   = config.cvar("sic_bullettime_sound_end",   'mb_bullettime/exit1.mp3', "The Sound when bullet time ends")
sic_bullettime_announce   = config.cvar("sic_bullettime_announce",   1, "This announces How many streaks a player has when he spawns")
config.text("\n")
config.text("**************************")
config.text("   Kill Streak Settings   ")
config.text("**************************")
sic_killingstreaks   = config.cvar("sic_killingstreaks",   1, "Enables/Disable Every so amount of kills bullet time will be activated")
sic_killingstreaks_kills   = config.cvar("sic_killingstreaks_kills",   5, "Amount of kills in a row needed")
sic_killingstreak_weapons = config.cvar("sic_killingstreak_weapons",     "m4a1 ak47 awp scout sg552 galil famas sg550 aug m249 g3sg1 ump45 mp5navy m3 xm1014 tmp mac10 p90 usp glock deagle p228 elite fiveseven", "Weapons that will be included in killing streak")
sic_killingstreaks_slowdown   = config.cvar("sic_killingstreaks_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_killingstreaks_time   = config.cvar("sic_killingstreaks_time",   5, "Amount of time bullet time last")
sic_killingstreaks_announce   = config.cvar("sic_killingstreaks_announce",   1, "Announces What player and amount of kills")
config.text("\n")
config.text("**************************")
config.text("      1vs 1 Settings      ")
config.text("**************************")
sic_1v1  = config.cvar("sic_1v1",   1, "Enables/Disbale When a player wins a 1v1 triigers a bullet time")
sic_1v1_slowdown   = config.cvar("sic_1v1_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_1v1_time   = config.cvar("sic_1v1_time",   5, "Amount of time bullet time last")
config.text("\n")
config.text("**************************")
config.text("     Grenade Settings     ")
config.text("**************************")
sic_grenade   = config.cvar("sic_grenade",   1, "Enables\disables when A player dies from a grenade")
sic_grenade_slowdown   = config.cvar("sic_grenade_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_grenade_time   = config.cvar("sic_grenade_time",   5, "Time the bullet time last")
config.text("\n")
config.text("**************************")
config.text("     Knife Settings     ")
config.text("**************************")
sic_knife   = config.cvar("sic_knife",   1, "Enables\disables when A player dies from a grenade")
sic_knife_slowdown   = config.cvar("sic_knife_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_knife_time   = config.cvar("sic_knife_time",   5, "Time the bullet time last")
config.text("\n")
config.text("**************************")
config.text("      Bomb Settings       ")
config.text("**************************")
sic_bomb   = config.cvar("sic_bomb",   1, "Enables\disables when c4 deatonates triggers Bullet time")
sic_bomb_slowdown   = config.cvar("sic_bomb_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_bomb_time   = config.cvar("sic_bomb_time",   5, "Amount of time bullet time last")
config.text("\n")
sic_bombdefusing   = config.cvar("sic_bombdefusing",   1, "Enables\disables when a player begins defusing Bomb triggering Bullet Time")
sic_bombdefusing_slowdown   = config.cvar("sic_bomb_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_bombdefusing_time   = config.cvar("sic_bomb_time",   5, "Amount of time bullet time last")
config.text("\n")
sic_bombdefused   = config.cvar("sic_bombdefused",   1, "Enables\disables when a player Defuses bomb triggering Bullet Time")
sic_bombdefused_slowdown   = config.cvar("sic_bombdefused_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_bombdefused_time   = config.cvar("sic_bombdefused_time",   5, "Amount of time bullet time last")

config.write()

class player:
    def __init__(self, userid):
        self.killed = 0
        self.userid = userid
    def giveKill(self):
        self.killed += 1
        if self.killed == player_dict[self.userid]['streak']:
            time = sic_killingstreaks_time
            speed = sic_killingstreaks_slowdown
            player_dict[self.userid]['streak'] += int(sic_killingstreaks_kills)
            if sic_killingstreaks_announce:
                es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #default is on a killing streak.  He\'s killed #green%s#default in a row' % (es.getplayername(self.userid), self.killed))
            bullettrigger(time,speed)
    def resetKill(self):
        self.killed = 0
        player_dict[self.userid]['streak'] = int(sic_killingstreaks_kills)

killers = {}


def load():
    config.execute()
    es.flags('remove', 'notify', 'sv_cheats')
    if not es.exists("command", str(sic_bullettime_trigger)):
        es.regsaycmd(str(sic_bullettime_trigger), "bullettime/trigger")
    setup_auth()

def unload():
    if es.exists("command", str(sic_bullettime_trigger)):
        es.unregsaycmd(str(sic_bullettime_trigger))

def bullettrigger(time,speed):
    if sic_bullettime:
        if timescale == 1:
            userid = es.getuserid()
            enter_sound(userid)
            es.server.queuecmd('est_Hook_Cheatish 1')
            es.server.queuecmd('sv_cheats 1')
            es.server.queuecmd('host_timescale %s' % speed)
            gamethread.delayed(time, end, (userid))


def enter_sound(userid):
    es.emitsound('player', userid, str(sic_bullettime_sound_enter), 1.0, 0)

def end(userid):
    es.emitsound('player', userid, str(sic_bullettime_sound_end), 1.0, 0)
    gamethread.delayed(1, es.server.queuecmd, 'host_timescale 1')
    es.server.queuecmd('sv_cheats 0')
    es.server.queuecmd('est_Hook_Cheatish 0')

def player_activate(ev):
    global killers
    killers[ev['userid']] = player(ev['userid'])
    if ev['userid'] not in player_dict:
        player_dict[ev['userid']] = {'streak':int(sic_killingstreaks_kills)}

def bomb_exploded(ev):
    if sic_bomb:
        if timescale == 1:
            time = sic_bomb_time
            speed = sic_bomb_slowdown
            es.msg('#multi', '#green[Bullet Time]#default The bomb has exploded triggering Bullet Time')
            bullettrigger(time, speed)

def bomb_begindefuse(ev):
    if sic_bombdefusing:
        if timescale == 1:
            time = sic_bombdefusing_time
            speed = sic_bombdefusing_slowdown
            es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #defaultBegan Defusing bomb triggering Bullet Time' % es.getplayername(ev['userid']))
            bullettrigger(time, speed)

def bomb_defused(ev):
    if sic_bombdefused:
        if timescale == 1:
            time = sic_bombdefused_time
            speed = sic_bombdefused_slowdown
            es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #defaultDefused bomb triggering Bullet Time' % es.getplayername(ev['userid']))
            bullettrigger(time, speed)

def player_death(ev):
    userid = ev['userid']
    weapon = ev['weapon']
    attacker = ev['attacker']
    if int(attacker):
        if weapon in str(sic_killingstreak_weapons).split(' '):
            killers[attacker].giveKill()
            killers[userid].resetKill()
    if sic_grenade:
        if weapon == 'hegrenade':
            if timescale == 1:
                time = sic_grenade_time
                speed = sic_grenade_slowdown
                es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #defaultkilled #lightgreen%s #defaultwith a He Grenade triggering Bullet Time' % (es.getplayername(userid), es.getplayername(attacker)))
                bullettrigger(time, speed)
    if sic_knife:
        if weapon == 'knife':
            if timescale == 1:
                time = sic_knife_time
                speed = sic_knife_slowdown
                es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #defaultkilled #lightgreen%s #defaultwith a Knife triggering Bullet Time' % (es.getplayername(userid), es.getplayername(attacker)))
                bullettrigger(time, speed)
    if sic_1v1:
        if es.getlivingplayercount() == 1:
            if not weapon in ['hegrenade','knife']:
                if timescale == 1:
                    time = sic_1v1_time
                    speed = sic_1v1_slowdown
                    es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #defaultkilled #lightgreen%s #defaultIn a 1v1 triggering Bullet Time' % (es.getplayername(userid), es.getplayername(attacker)))
                    bullettrigger(time, speed)

def player_say(ev):
    es.msg(killers)

def trigger():
     if isAuthed(userid):
        if es.getargc() >= 2:
            time = es.getuserid(es.getargv(1))
            speed = int(es.getargv(2))
            bullettrigger(time, speed)
        else:
            es.tell(es.getcmduserid(), '#multi', '#greenInvalide Syntax #lightgreen@god <name/userid/name> <1-on/0-off>')
    else:
        es.tell(es.getcmduserid(), '#multi','#greenYou are not authorized to run this command')

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('skins_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'skins_admin')
    else:
        isAuthed = lambda x: False

def player_disconnect(ev):
    del killers[ev['userid']]
    del player_dict[ev['userid']]